// CatTail.cpp : implementation file
//

#include "stdafx.h"
#include "CatTail.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCatTail

CCatTail::CCatTail()
{
}

CCatTail::~CCatTail()
{
}


BEGIN_MESSAGE_MAP(CCatTail, CCatPart)
        //{{AFX_MSG_MAP(CCatTail)
        ON_WM_LBUTTONDOWN()
        ON_WM_LBUTTONUP()
        ON_WM_MOUSEMOVE()
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCatTail message handlers


/****************************************************************************
*                           CCatTail::OnLButtonDown
* Inputs:
*       UINT nFlags: ignored
*       CPoint point: ignored
* Result: void
*       
* Effect: 
*       Notifies the parent that the button has been pressed, and sets capture
****************************************************************************/

void CCatTail::OnLButtonDown(UINT nFlags, CPoint point) 
   {
    GetParent()->SendMessage(WM_COMMAND, (WPARAM)MAKELONG(GetDlgCtrlID(), CT_LBUTTONDOWN), (LPARAM)m_hWnd);        
    CPoint where = point;
    ClientToScreen(&where);

    CRect parent;
    GetParent()->GetWindowRect(&parent);
    offset.x = parent.left;
    offset.y = parent.top;
    offset -= where;

    SetCapture();

    CStatic::OnLButtonDown(nFlags, point);
   }

/****************************************************************************
*                            CCatTail::OnLButtonUp
* Inputs:
*       UINT nFlags: ignored
*       CPoint point: ignored
* Result: void
*       
* Effect: 
*       If we had capture, notifies the parent that the button has been
*       released, and releases capture
****************************************************************************/

void CCatTail::OnLButtonUp(UINT nFlags, CPoint point) 
   {
    if(GetCapture() != NULL)
       { /* had capture */
        ReleaseCapture();

        GetParent()->SendMessage(WM_COMMAND, (WPARAM)MAKELONG(GetDlgCtrlID(), CT_LBUTTONUP), (LPARAM)m_hWnd);
       } /* had capture */
    CStatic::OnLButtonUp(nFlags, point);
   }

/****************************************************************************
*                             CCatTail::DrawPath
* Inputs:
*       CWnd * wnd: Window whose coordinates will be used for the path
*       CDC & dc: DC into which path is drawn
* Result: void
*       
* Effect: 
*       Draws the path in the DC
*
*       +----+--------------+-----+
*       |   /################\    |
*       |  /##################\   |
*       | /##/              \##\  |
*       |/##/                \##\ |
*      C|##/D                 \##\|B
*       |                     E|##|
*       |                      |##|
*       |                      |##|
*       |                      |##|
*       |                      |##|
*       |                      |##|
*       |                      |##|
*       |                      |##|
*       |                      |##|
*       |                      |##|
*       |                      |##|
*       |                      |##|
*       |                      |##|
*       |                      |##|
*       |                      |##|
*       |                      |##|
*       |                      |##|
*       |                      |##|
*       |                      |##|
*       |                      |##|
*       +----------------------+--+A
*                              F
****************************************************************************/

void CCatTail::DrawPath(CWnd * wnd, CDC & dc)
    {
     int TAIL_WIDTH = 3 * ::GetSystemMetrics(SM_CXBORDER);

     CRect r;
     GetWindowRect(&r);
     wnd->ScreenToClient(&r);

     dc.BeginPath();
     // A
     dc.MoveTo(r.right, r.bottom);
     // A-B
     dc.LineTo(r.right, r.top + r.Width()/2);
     // B-C
     dc.AngleArc(r.left + r.Width() / 2,
                 r.top + r.Width() / 2,
                 r.Width() / 2,
                 0, 180);

     // C-D
     dc.LineTo(r.left + TAIL_WIDTH, r.top + r.Width() / 2);

     // D-E
     dc.AngleArc(r.left + r.Width() / 2,
                 r.top + r.Width() / 2,
                 r.Width() / 2 - 2 * TAIL_WIDTH,
                 180, -180);

     // E-F
     dc.LineTo(r.right - TAIL_WIDTH, r.bottom);
     // F-A
     dc.CloseFigure();

     dc.EndPath();
     
    } // CCatTail::DrawPath

/****************************************************************************
*                            CCatTail::OnMouseMove
* Inputs:
*       UINT nFlags:
*       CPoint point:
* Result: void
*       
* Effect: 
*       Passes the mouse-move to the parent
****************************************************************************/

void CCatTail::OnMouseMove(UINT nFlags, CPoint point) 
   {
    // Figure out how far to move the window
    if(GetCapture() != NULL)
       { /* has capture */
        CPoint pt = point;
        ClientToScreen(&pt);
        pt += offset;
        GetParent()->SetWindowPos(NULL,
                                  pt.x, pt.y,
                                  0, 0,
                                  SWP_NOSIZE | SWP_NOZORDER);
       } /* has capture */
    //CCatPart::OnMouseMove(nFlags, point);
   }
