// Head.cpp : implementation file
//

#include "stdafx.h"
#include "Head.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static const UINT UWM_QUERY_COLOR = ::RegisterWindowMessage(UWM_QUERY_COLOR_MSG);

/////////////////////////////////////////////////////////////////////////////
// CHead

CHead::CHead()
{
 themood = HAPPY;
}

CHead::~CHead()
{
}


BEGIN_MESSAGE_MAP(CHead, CCatPart)
        //{{AFX_MSG_MAP(CHead)
        ON_WM_PAINT()
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHead message handlers

void CHead::OnPaint() 
   {
    CPaintDC dc(this); // device context for painting
        
    int save = dc.SaveDC();
    int SMILE_HEIGHT = 7 * ::GetSystemMetrics(SM_CYBORDER);

    CRect r;
    GetClientRect(&r);

    dc.FillSolidRect(&r, (COLORREF)GetParent()->SendMessage(UWM_QUERY_COLOR));
    
    int SMILE_WIDTH = (int)(0.4 * (double)r.Width());
    CRect smile;
    smile.left = r.Width() / 2 - SMILE_WIDTH / 2;
    smile.top = (int) ( (0.75) * (double)r.Height());
    smile.right = r.Width() / 2 + SMILE_WIDTH / 2;
    smile.bottom = smile.top + SMILE_HEIGHT;
        
    switch(themood)
       { /* mood */
        case HAPPY:
           dc.MoveTo(smile.left, smile.top);
           dc.LineTo(smile.left + SMILE_WIDTH / 4, smile.bottom);
           dc.LineTo(smile.right - SMILE_WIDTH / 4, smile.bottom);
           dc.LineTo(smile.right, smile.top);
           break;
        case NEUTRAL:
           dc.MoveTo(smile.left, smile.top + smile.Height() / 2);
           dc.LineTo(smile.right, smile.top + smile.Height() / 2);
           break;
        case SAD:
           dc.MoveTo(smile.left, smile.bottom);
           dc.LineTo(smile.left + SMILE_WIDTH / 4, smile.top);
           dc.LineTo(smile.right - SMILE_WIDTH / 4, smile.top);
           dc.LineTo(smile.right, smile.bottom);
           break;
        case STARTLED:
           { /* startled */
            //  /\/\/\/\  <= Cat's startled expression (n = 4)
            //  |      |
            //  left   right
#define MAX_WIGGLES 6
            dc.MoveTo(smile.left, smile.bottom);
            UINT wiggle = smile.Width() / MAX_WIGGLES;
            for(int i = 0; i < MAX_WIGGLES; i++)
               { /* draw one wiggle */
                dc.LineTo(smile.left + i *  wiggle + wiggle/2, smile.top);
                dc.LineTo(smile.left + (i + 1) * wiggle, smile.bottom);
               } /* draw one wiggle */
           } /* startled */
       } /* mood */

    int EYE_SIZE = 6 * ::GetSystemMetrics(SM_CYBORDER);
    CBrush br;
    br.CreateStockObject(BLACK_BRUSH);
    dc.SelectObject(&br);
    CRect RightEye(smile.left, (int) ( (0.38)*(double)r.Height()),
                   smile.left + EYE_SIZE, 0);
    RightEye.bottom = RightEye.top + EYE_SIZE;

    CRect LeftEye(smile.right - EYE_SIZE, RightEye.top,
                  smile.right, RightEye.bottom);

    dc.Ellipse(&RightEye);
    dc.Ellipse(&LeftEye);

    dc.RestoreDC(save);
    // Do not call CCatPart::OnPaint() for painting messages
   }

/****************************************************************************
*                               CHead::SetMood
* Inputs:
*       mood t: Desired mood
* Result: void
*       
* Effect: 
*       Sets the mood of the cat
****************************************************************************/

void CHead::SetMood(mood t)
    {
     if(t == themood)
        return;
     themood = t;
     Invalidate(TRUE);
    } // CHead::SetMood

/****************************************************************************
*                               CHead::DrawPath
* Inputs:
*       CWnd * wnd: Window in which path is drawn
*       CDC & dc: DC into which it is drawn 
* Result: void
*       
* Effect: 
*       Draws the path for the head
****************************************************************************/

void CHead::DrawPath(CWnd * wnd, CDC & dc)
    {
     CRect r;
     GetWindowRect(&r);
     wnd->ScreenToClient(&r);
     dc.BeginPath();
     dc.Ellipse(&r);
     dc.EndPath();
    } // CHead::DrawPath
