// TextButton.cpp : implementation file
//

#include "stdafx.h"
#include "TextButton.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTextButton

CTextButton::CTextButton()
{
}

CTextButton::~CTextButton()
{
}


BEGIN_MESSAGE_MAP(CTextButton, CButton)
        //{{AFX_MSG_MAP(CTextButton)
        ON_WM_ERASEBKGND()
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTextButton message handlers

void CTextButton::DrawItem(LPDRAWITEMSTRUCT dis) 
   {
    CDC * dc = CDC::FromHandle(dis->hDC);
    CRect r;
    GetClientRect(&r);

    int save = dc->SaveDC();

    COLORREF color;
    color = dis->itemState & ODS_SELECTED ? RGB(0,255,0) : RGB(255, 0, 0);
    CBrush br(color);
    dc->SelectObject(&br);

    CreateButtonPath(*dc);

    dc->SelectClipPath(RGN_COPY);

    dc->PatBlt(0, 0, r.Width(), r.Height(), PATCOPY);

    dc->StrokePath();
    
    dc->RestoreDC(save);
   }

void CTextButton::PreSubclassWindow() 
   {
    CClientDC dc(this);
    int save = dc.SaveDC();

    CreateButtonPath(dc);


    CRgn region;
    VERIFY(region.CreateFromPath(&dc));
    VERIFY(SetWindowRgn((HRGN)region, TRUE));
    region.Detach(); // must not close handle
    dc.RestoreDC(save);   
    CButton::PreSubclassWindow();
   }

/****************************************************************************
*                        CTextButton::CreateButtonPath
* Inputs:
*       CDC & dc: DC to create path in
* Result: void
*       
* Effect: 
*       Creates a path in the DC
****************************************************************************/

void CTextButton::CreateButtonPath(CDC & dc)
    {
     CString s;
     GetWindowText(s); // get character that forms button

     //::SetGraphicsMode(dc.m_hDC, GM_ADVANCED);
     CRect r;
     GetClientRect(&r);
     CFont * f;
     f = GetFont();
     LOGFONT lf;
     f->GetLogFont(&lf);
     CFont clipfont;
     lf.lfHeight = r.Height();
     lf.lfWeight = FW_EXTRABOLD;
     clipfont.CreateFontIndirect(&lf);

     dc.SetBkMode(TRANSPARENT);
     CFont * old = dc.SelectObject(&clipfont);
     dc.SetTextAlign(TA_CENTER);

     dc.BeginPath();
     dc.TextOut(r.Width() / 2, 0, s);
     dc.EndPath();

     dc.SelectObject(old);

#ifdef _DEBUG
     int size = dc.GetPath(NULL, NULL, 0);
     LPPOINT points = new POINT[size];
     LPBYTE types = new BYTE[size];
     dc.GetPath(points, types, size);
     CString line;
     for(int i = 0; i < size; i++)
        { /* scan points */
         CString t;
         t.Format(_T("[%4d, %4d] "), points[i].x, points[i].y);
         line += t;
         switch(types[i] & ~PT_CLOSEFIGURE)
            { /* types */
             case PT_MOVETO:
                line += _T("PT_MOVETO");
                break;
             case PT_LINETO:
                line += _T("PT_LINETO");
                break;
             case PT_BEZIERTO:
                line += _T("PT_BEZIERTO");
                break;
            } /* types */
         if(types[i] & PT_CLOSEFIGURE)
            line += _T(":PT_CLOSEFIGURE");

         line += _T("\r\n");
        } /* scan points */
     delete points;
     delete types;
#endif     
    } // CTextButton::CreateButtonPath

/****************************************************************************
*                          CTextButton::OnEraseBkgnd
* Inputs:
*       CDC * pDC: DC to use
* Result: BOOL
*       TRUE, always
* Effect: 
*       Does nothing. This prevents the DefWindowPRoc backround erasure,
*       which is not clipped by the SetWindowRgn region.
****************************************************************************/

BOOL CTextButton::OnEraseBkgnd(CDC* pDC) 
   {
    return TRUE;  
    // return CButton::OnEraseBkgnd(pDC); // Do not call superclass
   }
