// WindowRegionDlg.cpp : implementation file
//

#include "stdafx.h"
#include "WindowRegion.h"
#include "WindowRegionDlg.h"
#include "CatTail.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static const COLORREF CatColor = RGB(192, 192, 192); 
static const UINT UWM_QUERY_COLOR = ::RegisterWindowMessage(UWM_QUERY_COLOR_MSG);
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
        CAboutDlg();

// Dialog Data
        //{{AFX_DATA(CAboutDlg)
        enum { IDD = IDD_ABOUTBOX };
        //}}AFX_DATA

        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CAboutDlg)
        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
        //}}AFX_VIRTUAL

// Implementation
protected:
        //{{AFX_MSG(CAboutDlg)
        //}}AFX_MSG
        DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
        //{{AFX_DATA_INIT(CAboutDlg)
        //}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
        CDialog::DoDataExchange(pDX);
        //{{AFX_DATA_MAP(CAboutDlg)
        //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
        //{{AFX_MSG_MAP(CAboutDlg)
                // No message handlers
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWindowRegionDlg dialog

CWindowRegionDlg::CWindowRegionDlg(CWnd* pParent /*=NULL*/)
        : CDialog(CWindowRegionDlg::IDD, pParent)
{
        //{{AFX_DATA_INIT(CWindowRegionDlg)
        //}}AFX_DATA_INIT
        // Note that LoadIcon does not require a subsequent DestroyIcon in Win32
        m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
        c_Mew = NULL;
}

void CWindowRegionDlg::DoDataExchange(CDataExchange* pDX)
{
        CDialog::DoDataExchange(pDX);
        //{{AFX_DATA_MAP(CWindowRegionDlg)
        DDX_Control(pDX, IDC_BALLOON_AREA, c_Balloon);
        DDX_Control(pDX, IDC_R_EAR, c_RightEar);
        DDX_Control(pDX, IDC_L_EAR, c_LeftEar);
        DDX_Control(pDX, IDC_TAIL, c_Tail);
        DDX_Control(pDX, IDC_RR, c_RightRearLeg);
        DDX_Control(pDX, IDC_RF, c_RightFrontLeg);
        DDX_Control(pDX, IDC_LR, c_LeftRearLeg);
        DDX_Control(pDX, IDC_LF, c_LeftFrontLeg);
        DDX_Control(pDX, IDC_HEAD, c_Head);
        DDX_Control(pDX, IDC_BODY, c_Body);
        DDX_Control(pDX, IDC_T, c_T);
        DDX_Control(pDX, IDC_C, c_C);
        DDX_Control(pDX, IDC_A, c_A);
        //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWindowRegionDlg, CDialog)
        //{{AFX_MSG_MAP(CWindowRegionDlg)
        ON_WM_SYSCOMMAND()
        ON_WM_PAINT()
        ON_WM_QUERYDRAGICON()
        ON_WM_CLOSE()
        ON_WM_NCHITTEST()
        ON_BN_CLICKED(IDC_A, OnA)
        ON_BN_CLICKED(IDC_C, OnC)
        ON_BN_CLICKED(IDC_T, OnT)
        ON_WM_RBUTTONDOWN()
        ON_COMMAND(IDM_ABOUT_CAT, OnAboutCat)
        ON_COMMAND(IDM_EXIT, OnExit)
        ON_WM_NCRBUTTONDOWN()
        ON_WM_ERASEBKGND()
        ON_WM_MOVE()
        //}}AFX_MSG_MAP
        ON_REGISTERED_MESSAGE(UWM_QUERY_COLOR, OnQueryColor)
        ON_CONTROL(CT_LBUTTONDOWN, IDC_TAIL, OnTailDown)
        ON_CONTROL(CT_LBUTTONUP,   IDC_TAIL, OnTailUp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWindowRegionDlg message handlers

/****************************************************************************
*                         CWindowRegionDlg::AddRegion
* Inputs:
*       CCatPart & part: Part of cat to draw
*       CRgn & windowrgn: Region to add to 
* Result: void
*       
* Effect: 
*       Adds the window regiion (as drawn by 'part') to the parent window
*       region 'rgn'
****************************************************************************/

void CWindowRegionDlg::AddRegion(CCatPart & part, CRgn & windowrgn)
    {
     CClientDC dc(this);
     CRgn rgn;
     part.DrawPath(this, dc);
     rgn.CreateFromPath(&dc);
     windowrgn.CombineRgn(&windowrgn, &rgn, RGN_OR);
    } // CWindowRegionDlg::AddRegion

/****************************************************************************
*                       CWindowRegionDlg::OnInitDialog
* Result: BOOL
*       TRUE, always
* Effect: 
*       Initializes the dialog
****************************************************************************/

BOOL CWindowRegionDlg::OnInitDialog()
   {
    CDialog::OnInitDialog();

    // Add "About..." menu item to system menu.

    // IDM_ABOUTBOX must be in the system command range.
    ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
    ASSERT(IDM_ABOUTBOX < 0xF000);
    
    CMenu* pSysMenu = GetSystemMenu(FALSE);
    if (pSysMenu != NULL)
       {
        CString strAboutMenu;
        strAboutMenu.LoadString(IDS_ABOUTBOX);
        if (!strAboutMenu.IsEmpty())
           {
            pSysMenu->AppendMenu(MF_SEPARATOR);
            pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
           }
       }

    // Set the icon for this dialog.  The framework does this automatically
    //  when the application's main window is not a dialog
    SetIcon(m_hIcon, TRUE);                 // Set big icon
    SetIcon(m_hIcon, FALSE);                // Set small icon
        
    CRect r;
    r.SetRectEmpty(); // create an empty region
        
    CRgn cat;
    cat.CreateRectRgnIndirect(&r);

    //================
    // Body
    //================
    AddRegion(c_Body, cat);
    
    //================
    // Head
    //================
    AddRegion(c_Head, cat);

    //================
    // Tail
    //================
    AddRegion(c_Tail, cat); 

    //================
    // Left rear leg
    //================
    AddRegion(c_LeftRearLeg, cat);
        
    //================
    // Right rear leg
    //================
    AddRegion(c_RightRearLeg, cat);

    //================
    // Left front leg
    //================
    AddRegion(c_LeftFrontLeg, cat);

    //================
    // Right front leg
    //================
    AddRegion(c_RightFrontLeg, cat);

        
    //================
    // Left ear
    //================
    AddRegion(c_LeftEar, cat);

    //================
    // Right ear
    //================
    AddRegion(c_RightEar, cat);

    //=========================
    // Define the window region
    //=========================
    SetWindowRgn((HRGN)cat, TRUE);
    cat.Detach(); // remove region handle to prevent killing
        
    // TODO: Add extra initialization here
        
    return TRUE;  // return TRUE  unless you set the focus to a control
   }

void CWindowRegionDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
        if ((nID & 0xFFF0) == IDM_ABOUTBOX)
        {
                CAboutDlg dlgAbout;
                dlgAbout.DoModal();
        }
        else
        {
                CDialog::OnSysCommand(nID, lParam);
        }
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CWindowRegionDlg::OnPaint() 
{
        if (IsIconic())
        {
                CPaintDC dc(this); // device context for painting

                SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

                // Center icon in client rectangle
                int cxIcon = GetSystemMetrics(SM_CXICON);
                int cyIcon = GetSystemMetrics(SM_CYICON);
                CRect rect;
                GetClientRect(&rect);
                int x = (rect.Width() - cxIcon + 1) / 2;
                int y = (rect.Height() - cyIcon + 1) / 2;

                // Draw the icon
                dc.DrawIcon(x, y, m_hIcon);
        }
        else
        {
                CDialog::OnPaint();
        }
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CWindowRegionDlg::OnQueryDragIcon()
{
        return (HCURSOR) m_hIcon;
}

void CWindowRegionDlg::OnOK() 
{
}

void CWindowRegionDlg::OnCancel() 
{
}

/****************************************************************************
*                          CWindowRegionDlg::OnClose
* Result: void
*       
* Effect: 
*       Closes the application
****************************************************************************/

void CWindowRegionDlg::OnClose() 
   {
    CDialog::OnOK();
   }

/****************************************************************************
*                        CWindowRegionDlg::OnNCHitTest
* Inputs:
*       CPoint point: Point, in client coordinates
* Result: UINT
*       An HT-code indicating where the mouse was clicked
****************************************************************************/
   
UINT CWindowRegionDlg::OnNcHitTest(CPoint point) 
   {
    return HTCAPTION;
        
    //return CDialog::OnNcHitTest(point);
   }

/****************************************************************************
*                            CWindowRegionDlg::OnC
* Result: void
*       
* Effect: 
*       Makes the cat happy
****************************************************************************/

void CWindowRegionDlg::OnC() 
   {
    c_Head.SetMood(CHead::HAPPY);
   }

/****************************************************************************
*                            CWindowRegionDlg::OnA
* Result: void
*       
* Effect: 
*       Makes the cat look neutral
****************************************************************************/

void CWindowRegionDlg::OnA() 
   {
    c_Head.SetMood(CHead::NEUTRAL);
   }

/****************************************************************************
*                            CWindowRegionDlg::OnT
* Result: void
*       
* Effect: 
*       Makes the cat look sad
****************************************************************************/

void CWindowRegionDlg::OnT() 
   {
    c_Head.SetMood(CHead::SAD);
   }

/****************************************************************************
*                       CWindowRegionDlg::OnRButtonDown
* Inputs:
*       UINT nFlags:
*(      CPOint point:
* Result: void
*       
* Effect: 
*       Handles the right-button-down in the client area
****************************************************************************/

void CWindowRegionDlg::OnRButtonDown(UINT nFlags, CPoint point) 
   {
    CMenu menu;
    menu.LoadMenu(IDR_MENU);
    menu.GetSubMenu(0)->TrackPopupMenu(0, point.x, point.y, this);
    CDialog::OnRButtonDown(nFlags, point);
   }

/****************************************************************************
*                        CWindowRegionDlg::OnAboutCat
* Result: void
*       
* Effect: 
*       Pops up the About dialog
****************************************************************************/

void CWindowRegionDlg::OnAboutCat() 
   {
    CAboutDlg dlgAbout;
    dlgAbout.DoModal();
   }

/****************************************************************************
*                          CWindowRegionDlg::OnExit
* Result: void
*       
* Effect: 
*       Exits the program, from the menu selection
****************************************************************************/

void CWindowRegionDlg::OnExit() 
   {
    CDialog::OnOK();       
   }

/****************************************************************************
*                      CWindowRegionDlg::OnNCRbuttonDown
* Inputs:
*       UINT nHitTest:
*       CPoint point:
* Result: void
*       
* Effect: 
*       Handles the right-button-down in the non-client area
****************************************************************************/

void CWindowRegionDlg::OnNcRButtonDown(UINT nHitTest, CPoint point) 
   {
    CMenu menu;
    menu.LoadMenu(IDR_MENU);
    menu.GetSubMenu(0)->TrackPopupMenu(0, point.x, point.y, this);
   }


/****************************************************************************
*                        CWindowRegionDlg::OnTailDown
* Result: void
*       
* Effect: 
*       Notices someone is trying to drag the cat by her tail
****************************************************************************/

void CWindowRegionDlg::OnTailDown()
    {
     c_Head.SetMood(CHead::STARTLED);
     c_Mew = new CBalloon;
     CRect r;
     c_Balloon.GetWindowRect(&r);

     c_Mew->Create(_T("m"), _T("Symbol"), WS_VISIBLE, r, this);
    } // CWindowRegionDlg::OnTailDown

/****************************************************************************
*                         CWindowRegionDlg::OnTailUp
* Result: void
*       
* Effect: 
*       Notices that the cat's tail has been released
****************************************************************************/

void CWindowRegionDlg::OnTailUp()
    {
     c_Head.SetMood(CHead::HAPPY);
     if(c_Mew != NULL)
         { /* stop mewing */
          c_Mew->DestroyWindow();
          c_Mew = NULL;
         } /* stop mewing */
    } // CWindowRegionDlg::OnTailUp

/****************************************************************************
*                       CWindowRegionDlg::OnEraseBkgnd
* Inputs:
*       CDC * pDC: DC
* Result: BOOL
*       TRUE, always
* Effect: 
*       Paints the cat color
****************************************************************************/

BOOL CWindowRegionDlg::OnEraseBkgnd(CDC* pDC) 
   {
    CRect r;
    GetClientRect(&r);
    pDC->FillSolidRect(&r, CatColor);
    return TRUE;
    //return CDialog::OnEraseBkgnd(pDC);
   }

/****************************************************************************
*                       CWindowRegionDlg::OnQueryColor
* Inputs:
*       WPARAM: ignored
*       LPARAM: ignored
* Result: (LRESULT)(COLORREF)
*       Color of cat
****************************************************************************/

LRESULT CWindowRegionDlg::OnQueryColor(WPARAM, LPARAM)
    {
     return (LRESULT)CatColor;
    } // CWindowRegionDlg::OnQueryColor

/****************************************************************************
*                          CWindowRegionDlg::OnMove
* Inputs:
*       int x: New horizontal position
*       int y: New vertical position
* Result: void
*       
* Effect: 
*       Drags the Mew! balloon along with the main window
****************************************************************************/

void CWindowRegionDlg::OnMove(int x, int y) 
   {
    CDialog::OnMove(x, y);
        
    CRect mew;
    if(c_Mew != NULL)
       { /* move mew */
        CRect mewframe;
        c_Balloon.GetWindowRect(&mewframe);
        c_Mew->SetWindowPos(NULL, mewframe.left, mewframe.top,
                           0, 0,
                           SWP_NOSIZE | SWP_NOZORDER);
       } /* move mew */
        
   }
